package utils

type DataType int

const (
	INVALID DataType = iota
	DATA_RESOURCE
	PROCESSING_RESOURCE
	STORAGE_RESOURCE
	DATACENTER_RESOURCE
	WORKFLOW_RESOURCE
	WORKFLOW
	WORKFLOW_EXECUTION
	WORKSPACE
)

var Str = [...]string{
	"invalid",
	"data_resource",
	"processing_resource",
	"storage_resource",
	"datacenter_resource",
	"workflow_resource",
	"workflow",
	"workflow_execution",
	"workspace",
}

func FromInt(i int) string {
	return Str[i]
}

func (d DataType) String() string {
	return Str[d]
}

// EnumIndex - Creating common behavior - give the type a EnumIndex functio
func (d DataType) EnumIndex() int {
	return int(d)
}
